<template>
  <div
    :class="[
      'drag-card',
      isEditMode && 'drag-card--draggable',
    ]"
    @dragend.prevent="handleDragEnd"
    @dragstart="handleDragStart"
    :draggable="isEditMode"
    :style="{
      left: `${posX}px`,
      top: `${posY}px`,
    }"
  >
    <div class="drag-card__heading">
      <DragIndicatorIcon v-if="isEditMode" />
      Heading
    </div>

    <div class="drag-card__content">
      <div>X: {{ posX - 32 }}px</div>
      <div>Y: {{ posY - 32 }}px</div>
      <div> {{ isDragging ? 'Dragging' : 'Static' }}</div>
    </div>

    <template v-if="isEditMode">
      <DragCardHandle position="e" />
      <DragCardHandle position="s" />
    </template>
  </div>
</template>

<script>
import DragCardHandle from './DragCardHandle.vue';
import DragIndicatorIcon from './DragIndicatorIcon.vue';

export default {
  components: {
    DragCardHandle,
    DragIndicatorIcon,
  },
  props: ['isEditMode'],
  data () {
    return {
      posX: 32,
      posY: 32,
      cursorStartX: 0,
      cursorStartY: 0,
      isDragging: false,
    };
  },
  methods: {
    handleDragStart (e) {
      this.isDragging = true;
      this.cursorStartX = e.offsetX;
      this.cursorStartY = e.offsetY;
    },
    handleDragEnd (e) {
      this.isDragging = false;

      const deltaX = e.offsetX - this.cursorStartX;
      const deltaY = e.offsetY - this.cursorStartY;

      this.posX += deltaX;
      this.posY += deltaY;
    },
  },
}
</script>

<style>
.drag-card {
  border: 1px solid rgba(0, 0, 0, 0.12);
  border-radius: 0.5rem;
  height: 360px;
  width: 480px;
  transition: box-shadow 150ms ease-in-out, background 150ms ease-in-out,
    transform 150ms ease-in-out;
  position: absolute;
  display: flex;
  flex-direction: column;
  background-color: white;
}

.drag-card--draggable:hover {
  cursor: grab;
  /* Elevation/03 dp */
  box-shadow: 0px 3px 4px rgba(0, 0, 0, 0.14), 0px 1px 8px rgba(0, 0, 0, 0.12),
    0px 3px 3px -2px rgba(0, 0, 0, 0.2);
  background-color: #fafafa;
}

.drag-card--draggable:active {
  cursor: grabbing;
  /* Elevation/06 dp */
  box-shadow: 0px 6px 10px rgba(0, 0, 0, 0.14), 0px 1px 18px rgba(0, 0, 0, 0.12),
    0px 3px 5px -1px rgba(0, 0, 0, 0.2);
  background-color: #f5f5f5;
  transform: scale(1.05);
}

.drag-card__heading {
  display: flex;
  align-items: center;
  gap: 1rem;
  font-size: 1.25rem;
  font-weight: 600;
  padding: 0.5rem 1rem;
  border-bottom: 1px solid rgba(0, 0, 0, 0.12);
}

.drag-card__content {
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  flex: 1 0 auto;
}

.drag-card--draggable .drag-card__heading,
.drag-card--draggable .drag-card__content {
  user-select: none;
}
</style>
